# mode: run
# distutils: language=c++
# distutils: extra_compile_args=-std=c++11
# tag: cpp

cdef cypclass A:
  int a
  void __init__(self, int arg=0):
    self.a = arg

  A __iadd__(self, A other):
    self.a += other.a

  int getter(self):
    return self.a

cdef cypclass B:
  int b
  void __init__(self, int arg=0):
    self.b = arg

  B __isub__(self, B other):
    self.b -= other.b

  int getter(self):
    return self.b

cdef cypclass C(A,B):
  void __init__(self, int arg=0):
    self.a = self.b = arg

cpdef bag():
  """
  >>> bag()
  3
  4
  8
  1
  8
  1
  """
  a = A(3)
  b = B(4)
  c = C(5)
  c += a
  c -= b
  print str(a.a) + '\n' + str(b.b) + '\n' + str(c.a) + '\n' + str(c.b)\
         + '\n' + str(A.getter(c)) + '\n' + str(B.getter(c))
