cdef struct SomeCStruct:
    # This type doesn't need the GIL
    int a # This is a C int
    double b # This is a C double

class SomePythonClass:
    # This type needs the GIL
    def __init__(self):
        a = 3 # This is a PyObject

cdef class SomeCythonClass:
    # This type needs the GIL
    cdef object a # This is a PyObject
    cdef int b # This is a C int
    def __init__(self):
        a = 3 # This is a PyObject

def test():
    # This function must hold the GIL to be able to instantiate the SomeCythonClass object
    cdef SomeCStruct stack_allocated_struct
    stack_allocated_struct.a = 42
    stack_allocated_struct.b = 4.2

    heap_allocated_cython = SomeCythonClass()
    heap_allocated_cython.b = stack_allocated_struct.a # This is a C assignation (both are C int)
    heap_allocated_cython.a = stack_allocated_struct.b # The C double is coerced to a PyObject before assignation
    print(heap_allocated_cython.a, heap_allocated_cython.b)
