cdef cypclass OK:
    """
    This is OK because the wrapper will pass a & b from __new__ to __init__ directly,
    and will quite blindly transfer the information about c presence in __new__ to __init__
    """
    __init__(self, int a, double b = 4.2, int c = 42):
        pass
    OK __new__(alloc, int a, double b, int c = 0):
        return alloc()

cdef cypclass KO:
    """
    This will fail because the wrapper knows b (in __new__) is optional,
    but doesn't know its default value, so it cannot pass it to __init__
    """
    __init__(self, int a, double b, int c = 42):
        pass
    KO __new__(alloc, int a, double b = 4.2, int c = 0):
        return alloc()

cdef void main() nogil:
    o1 = OK(2, 2.4)
    o2 = KO(3, 2.1)
